Skip to main content

Sweep Line - Question 1

Question 1: The minimum meeting room needed

Say we have had a list of meetings with start_time and end_time. For each meeting room, only one meeting can be hold once the meeting starts, and it cannot hold the next meeting until the first one ends. For example, if the first meeting start at 1 and end at 10, then the meeting room can only hold a second meeting starting at or later than 10.

The question is to find the minimum number of meeting rooms needed to hold all the meetings.

Example 1:

meetings = [[2, 5], [4, 6], [5, 9]]

Ans: 2

the first meeting room can hold: [2, 5], [5, 9];

the second meeting room can hold: [4, 6].

Example 2:

meetings = [[1, 10], [2, 3], [3, 7], [4, 6], [5, 8], [6, 9], [7, 11], [10, 12]]

Ans: 4

the first meeting room can hold: [1, 10], [10, 12];

the second meeting room can hold: [2, 3], [3, 7], [7, 11];

the third meeting room can hold: [4, 6], [6, 9];

the fourth meeting room can hold: [5, 8].


Analysis:

As indicated by the second example, we can sort the meeting time based on the starting time. Once we choose the first meeting, then we can search for the next meeting that can be held in the same meeting room. The starting time of the next meeting should be equal to or larger than the ending time of the first meeting.

In this way, we can find a set of meetings that can be held in one meeting room.

But there are other meetings which cannot be held in the same meeting room.

So we need to search the list again, and just repeat the process for the first meeting room, to find all the meetings that can be held in the second meeting room.

To avoid redundancy, we can use a labeling vector to label whether the meeting has been held or not. Or to make sure each meeting be held once.

The time complexity is O(N^2). The initial sorting is O(N^log(N)) which is not the most expensive step.

Is there a faster way?

The answer is yes. For example, using the scanning line algorithm.

The first step is to label the starting and ending times of all meetings. The start time can be 1, the end time can be -1. Then sort all the times increasingly. If the start time equals to end time, then put the end time first.

After this step, we just need to scan through the sorted time list once, to calculate the maximum number of meeting that have overlaps in time. This value is exactly the minimum number of meeting room needed to hold all the meetings on the list.


See the code below:

int minMR(vector<vector<int>>& rs) {
    int res = 0, ct = 0;
    vector<vector<int>> data;
    for(auto &a : rs) {
	data.push_back({a[0], 1});
	data.push_back({a[1], -1});
    }
    sort(data.begin(), data.end(), [](vector<int> &a, vector<int> &b) {
	if(a[0] == b[0]) return a[1] < b[1];
	return a[0] < b[0];
    });
    for(auto &a : data) {
	if(a[1] == 1) ++ct;
	else --ct;
	res = max(res, ct);
    }
    return res;
}



Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class